<h1 align="center">Data</h1>
<p align="center">
The main data can be downloaded from my <a href="https://drive.google.com/open?id=1pZZQO69OHVWZ-NQ1zyvNOBEB-2BcC08Q"><b>Google Drive</b></a> with the links below.
The directory structure should be:
</p>
<pre>
<a href="https://drive.google.com/open?id=1fuHuH_I7c0Hu8TAq-zOG-jXwszCF9Z1B">Tennis</a>/
└── <a href="https://drive.google.com/open?id=1pZZQO69OHVWZ-NQ1zyvNOBEB-2BcC08Q">data</a>/
    ├── <a href="https://drive.google.com/open?id=1XOW8JG-rznZ7rTXCddZaROApnEoV9KZv">annotations</a> (9.5 MB)
    ├── <a href="https://drive.google.com/open?id=1KrBUmPhsipYjCGWxyPsxM93-2NEKfPmF">features</a> (13.2 GB)
    ├── <a href="https://drive.google.com/open?id=1_xP96GcfFl2AX5S7lfzMry8gmmnuQlBw">flow</a> (217 GB)
    ├── <a href="https://drive.google.com/open?id=1nhV41NGKDudPlwOTPpo2oUlZAX_oTGeu">frames</a> (217 GB)
    ├── <a href="https://drive.google.com/open?id=1-QfoToFVyfH5osQMefGyKbY361ASDihG">splits</a> (36.3 MB)
    └── <a href="https://drive.google.com/open?id=1rGIJIwmp_jhB8eoW-KVNYKHlu56l5UAq">videos</a> (11.1 GB)
</pre>

<p align="center">The <code>frames</code> and <code>flow</code> directories can be generated with the <a href="process.py"><code>process.py</code></a> script. Please first download the <a href="https://drive.google.com/open?id=1AwUS8uBLc68j2jMc1dvC8XA4shJ_Amq0">FlowNet</a> model before running this script, putting in the <a href="../models/vision/flownet"><code>../models/vision/flownet</code></a> directory.

<ul>
    <li><code><b>annotations</b></code> stores <code>.json</code> files for each video generated by the <a href="https://github.com/HaydenFaulkner/TemporalEventAnnotator">annotator</a>, as well as other annotation and commentary <code>.txt</code> files.</li>
    <li><code><b>features</b></code> stores <code>.npy</code> feature files for frames for each video in subdirectories.</li>
    <li><code><b>flow</b></code> stores <code>.jpg</code> image files for flow frames for each video in subdirectories.</li>
    <li><code><b>frames</b></code> stores <code>.jpg</code> image files for RGB frames for each video in subdirectories.</li>
    <li><code><b>splits</b></code> stores <code>.txt</code> files for each split (train, val, test).</li>
    <li><code><b>videos</b></code> stores the original video files as <code>.mp4</code> files.</li>
</ul>
